<template>
    <div>
        <canvas class="canvas" height="500" width="1000"></canvas>
    </div>
</template>

<script>
    var hsl = require('hsl-to-hex')

    export default {
        data() {
            return {
                canvas: '',
                ctx: '',
                text: 'Welcome to my world',
                partialText: '',
                rotation: 0,
                hue1: 0,
                hue2: 0,
                color1: '',
                color2: '',
                stars: []
            }
        },
        mounted() {
            this.canvas = document.querySelector('.canvas');
            this.ctx = this.canvas.getContext("2d");
            this.rotation = Math.floor(Math.random() * 360);
            this.setupCanvas();
            this.setHue();
            this.updateCanvas();
            window.addEventListener('resize', this.setupCanvas)
        },
        methods: {
            setHue () {
                const h = Math.floor(Math.random()*361);
                this.hue1 = h;
                this.hue2 = h + Math.floor(Math.random()*280) + 40;
            },
            setupCanvas () {
                this.canvas.width = window.innerWidth;
                this.canvas.height = window.innerHeight/2;
                this.ctx.font = '120px Impact';
                this.ctx.strokeStyle = 'whitesmoke';
                this.ctx.textAlign = "center";
                this.ctx.textBaseline = 'middle';
                this.welcomeText();
            },
            changeCanvas() {
                this.rotation = this.addDegrees();
                this.hue1++;
                if (this.hue1 >= 360) {
                    this.hue1 = 0;
                }
                this.hue2++;
                if (this.hue1 >= 360) {
                    this.hue1 = 0;
                }
                this.canvas.style.background = `linear-gradient(${this.rotation}deg, ${this.generateColor(this.hue1)}, ${this.generateColor(this.hue2)})`;
            },
            updateCanvas() {
                setInterval(this.changeCanvas, 100);
            },
            addDegrees() {
                return this.rotation + 1;
            },
            generateColor(hue) {
                var hex = hsl(hue, 100, 10);
                return hex;
            },
            welcomeText()
            {
                this.ctx.strokeText(this.text,this.canvas.width/2, this.canvas.height/2);

//                const that = this;
//                var i = 0;
//                var addText = setInterval(
//                    function () {
//                        that.partialText = that.text.slice(0,i);
//                        that.ctx.clearRect(0, 0,that.canvas.width, that.canvas.height);
//                        that.ctx.strokeText(that.partialText,that.canvas.width/2, that.canvas.height/2);
//                        i == that.text.length ? clearInterval(addText) : '';
//                        i++;
//                    }, 200);
            }
        }
    }
</script>

<style>

</style>